<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInterfacePersonResult_V10 ArrayType
 * @subpackage Arrays
 */
class ArrayOfInterfacePersonResult_V10 extends AbstractStructArrayBase
{
    /**
     * The InterfacePersonResult_V10
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InterfacePersonResult_V10[]
     */
    public $InterfacePersonResult_V10;
    /**
     * Constructor method for ArrayOfInterfacePersonResult_V10
     * @uses ArrayOfInterfacePersonResult_V10::setInterfacePersonResult_V10()
     * @param \StructType\InterfacePersonResult_V10[] $interfacePersonResult_V10
     */
    public function __construct(array $interfacePersonResult_V10 = array())
    {
        $this
            ->setInterfacePersonResult_V10($interfacePersonResult_V10);
    }
    /**
     * Get InterfacePersonResult_V10 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InterfacePersonResult_V10[]|null
     */
    public function getInterfacePersonResult_V10()
    {
        return isset($this->InterfacePersonResult_V10) ? $this->InterfacePersonResult_V10 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInterfacePersonResult_V10 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInterfacePersonResult_V10 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInterfacePersonResult_V10ForArrayConstraintsFromSetInterfacePersonResult_V10(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfInterfacePersonResult_V10InterfacePersonResult_V10Item) {
            // validation for constraint: itemType
            if (!$arrayOfInterfacePersonResult_V10InterfacePersonResult_V10Item instanceof \StructType\InterfacePersonResult_V10) {
                $invalidValues[] = is_object($arrayOfInterfacePersonResult_V10InterfacePersonResult_V10Item) ? get_class($arrayOfInterfacePersonResult_V10InterfacePersonResult_V10Item) : sprintf('%s(%s)', gettype($arrayOfInterfacePersonResult_V10InterfacePersonResult_V10Item), var_export($arrayOfInterfacePersonResult_V10InterfacePersonResult_V10Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InterfacePersonResult_V10 property can only contain items of type \StructType\InterfacePersonResult_V10, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InterfacePersonResult_V10 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InterfacePersonResult_V10[] $interfacePersonResult_V10
     * @return \ArrayType\ArrayOfInterfacePersonResult_V10
     */
    public function setInterfacePersonResult_V10(array $interfacePersonResult_V10 = array())
    {
        // validation for constraint: array
        if ('' !== ($interfacePersonResult_V10ArrayErrorMessage = self::validateInterfacePersonResult_V10ForArrayConstraintsFromSetInterfacePersonResult_V10($interfacePersonResult_V10))) {
            throw new \InvalidArgumentException($interfacePersonResult_V10ArrayErrorMessage, __LINE__);
        }
        if (is_null($interfacePersonResult_V10) || (is_array($interfacePersonResult_V10) && empty($interfacePersonResult_V10))) {
            unset($this->InterfacePersonResult_V10);
        } else {
            $this->InterfacePersonResult_V10 = $interfacePersonResult_V10;
        }
        return $this;
    }
    /**
     * Add item to InterfacePersonResult_V10 value
     * @throws \InvalidArgumentException
     * @param \StructType\InterfacePersonResult_V10 $item
     * @return \ArrayType\ArrayOfInterfacePersonResult_V10
     */
    public function addToInterfacePersonResult_V10(\StructType\InterfacePersonResult_V10 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InterfacePersonResult_V10) {
            throw new \InvalidArgumentException(sprintf('The InterfacePersonResult_V10 property can only contain items of type \StructType\InterfacePersonResult_V10, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InterfacePersonResult_V10[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\InterfacePersonResult_V10|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\InterfacePersonResult_V10|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\InterfacePersonResult_V10|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\InterfacePersonResult_V10|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\InterfacePersonResult_V10|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InterfacePersonResult_V10
     */
    public function getAttributeName()
    {
        return 'InterfacePersonResult_V10';
    }
}
